You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

1724 lines
57 KiB

  1. #!/bin/bash
  2. . /etc/shlib
  3. include common
  4. include parse
  5. include cmdline
  6. include config
  7. [[ "${BASH_SOURCE[0]}" != "${0}" ]] && SOURCED=true
  8. version=0.1
  9. desc='Manage 0k related installs'
  10. help=""
  11. ##
  12. ## Functions
  13. ##
  14. is-port-open() {
  15. local host="$1" port="$2" timeout=5
  16. start="$SECONDS"
  17. debug "Testing if $host's port $2 is open ..."
  18. while true; do
  19. timeout 1 bash -c "</dev/tcp/${host}/${port}" >/dev/null 2>&1 && break
  20. sleep 0.2
  21. if [ "$((SECONDS - start))" -gt "$timeout" ]; then
  22. return 1
  23. fi
  24. done
  25. debug " .. $host's port $2 is open."
  26. return 0
  27. }
  28. resolve() {
  29. local ent hostname="$1"
  30. debug "Resolving $1 ..."
  31. if ent=$(getent ahosts "$hostname"); then
  32. ent=$(echo "$ent" | egrep ^"[0-9]+.[0-9]+.[0-9]+.[0-9]+\s+" | \
  33. head -n 1 | awk '{ print $1 }')
  34. debug " .. resolved $1 to $ent."
  35. echo "$ent"
  36. else
  37. debug " .. couldn't resolve $1."
  38. return 1
  39. fi
  40. }
  41. set_errlvl() { return "${1:-1}"; }
  42. export master_pid=$$
  43. ssh:open() {
  44. local hostname ssh_cmd ssh_options
  45. ssh_cmd=(ssh)
  46. ssh_options=()
  47. while [ "$#" != 0 ]; do
  48. case "$1" in
  49. "--stdin-password")
  50. ssh_cmd=(sshpass "${ssh_cmd[@]}")
  51. ;;
  52. -o)
  53. ssh_options+=("$1" "$2")
  54. shift
  55. ;;
  56. *)
  57. [ -z "$hostname" ] && hostname="$1" || {
  58. err "Surnumerous positional argument '$1'. Expecting only hostname."
  59. return 1
  60. }
  61. ;;
  62. esac
  63. shift
  64. done
  65. full_cmd=(
  66. "${ssh_cmd[@]}"
  67. -o ControlPath=/tmp/ssh-control-master-${master_pid}-$hostname \
  68. -o ControlMaster=auto -o ControlPersist=900 \
  69. -o ConnectTimeout=5 -o StrictHostKeyChecking=no \
  70. "${ssh_options[@]}" \
  71. "$hostname" "$@" -- true)
  72. "${full_cmd[@]}" >/dev/null 2>&1 || {
  73. err "Failed: ${full_cmd[*]}"
  74. return 1
  75. }
  76. trap_add EXIT,INT 'ssh:quit "$hostname"'
  77. }
  78. ssh:rsync() {
  79. local src="$1" dst="$2"
  80. hostname=${src%%:*}
  81. hostname=${hostname#*@}
  82. local rsync_ssh_options=(
  83. -o ControlPath="/tmp/ssh-control-master-${master_pid}-$hostname"
  84. -o ControlMaster=auto
  85. -o ControlPersist=900
  86. -o ConnectTimeout=10
  87. -o StrictHostKeyChecking=no
  88. )
  89. if ! ssh:run "root@$hostname" -- type -p rsync </dev/null >/dev/null; then
  90. info "No 'rsync' available on '$hostname'. Requesting installation..."
  91. ssh:run "root@$hostname" -- apt-get install rsync -y || {
  92. err "Installation of 'rsync' failed on '$hostname'"
  93. return 1
  94. }
  95. fi
  96. local cmd=(
  97. rsync -e "ssh ${rsync_ssh_options[*]}"
  98. -azvArH --delete --delete-excluded
  99. --partial --partial-dir .rsync-partial
  100. "$src" "$dst"
  101. )
  102. "${cmd[@]}"
  103. }
  104. ssh:open-try() {
  105. local opts hostnames
  106. opts=()
  107. hostnames=()
  108. while [ "$#" != 0 ]; do
  109. case "$1" in
  110. -o)
  111. opts+=("$1" "$2")
  112. shift
  113. ;;
  114. *)
  115. hostnames+=("$1")
  116. ;;
  117. esac
  118. shift
  119. done
  120. password=''
  121. for host in "${hostnames[@]}"; do
  122. debug "Trying $host with publickey."
  123. ssh:open -o PreferredAuthentications=publickey \
  124. "${opts[@]}" \
  125. "$host" >/dev/null 2>&1 && {
  126. echo "$host"$'\n'"$password"$'\n'
  127. return 0
  128. }
  129. debug " .. failed connecting to $host with publickey."
  130. done
  131. local times=0 password
  132. while [ "$((++times))" -le 3 ]; do
  133. read -sp "$HOST's password: " password
  134. errlvl="$?"
  135. echo >&2
  136. if [ "$errlvl" -gt 0 ]; then
  137. exit 1
  138. fi
  139. for host in "${hostnames[@]}"; do
  140. debug "Trying $host with password ($times/3)"
  141. echo "$password" | ssh:open -o PreferredAuthentications=password \
  142. --stdin-password \
  143. "${opts[@]}" \
  144. "$host" >/dev/null 2>&1 && {
  145. echo "$host"$'\n'"$password"$'\n'
  146. return 0
  147. }
  148. debug " .. failed connecting to $host with password."
  149. done
  150. err "login failed. Try again... ($((times+1))/3)"
  151. done
  152. return 1
  153. }
  154. ssh:run() {
  155. local hostname="$1" ssh_options cmd
  156. shift
  157. ssh_options=()
  158. cmd=()
  159. while [ "$#" != 0 ]; do
  160. case "$1" in
  161. "--")
  162. shift
  163. cmd+=("$@")
  164. break
  165. ;;
  166. *)
  167. ssh_options+=("$1")
  168. ;;
  169. esac
  170. shift
  171. done
  172. ## XXXvlab: keeping in case we need some debug
  173. # debug "$DARKCYAN$hostname$NORMAL $WHITE\$$NORMAL" "$@"
  174. # debug "Running cmd: ${cmd[*]}"
  175. # for arg in "${cmd[@]}"; do
  176. # debug "$arg"
  177. # done
  178. {
  179. {
  180. ssh -o ControlPath=/tmp/ssh-control-master-${master_pid}-$hostname \
  181. -o ControlMaster=auto -o ControlPersist=900 \
  182. -o "StrictHostKeyChecking=no" \
  183. "${ssh_options[@]}" "$hostname" -- "${cmd[@]}"
  184. } 3>&1 1>&2 2>&3 ## | sed -r "s/^/$DARKCYAN$hostname$NORMAL $DARKRED\!$NORMAL /g"
  185. set_errlvl "${PIPESTATUS[0]}"
  186. } 3>&1 1>&2 2>&3
  187. }
  188. ssh:quit() {
  189. local hostname="$1"
  190. shift
  191. ssh -o ControlPath=/tmp/ssh-control-master-${master_pid} \
  192. -o ControlMaster=auto -o ControlPersist=900 -O exit \
  193. "$hostname" 2>/dev/null
  194. }
  195. is_ovh_domain_name() {
  196. local domain="$1"
  197. [[ "$domain" == *.ovh.net ]] && return 0
  198. [[ "$domain" == "ns"*".ip-"*".eu" ]] && return 0
  199. return 1
  200. }
  201. is_ovh_hostname() {
  202. local domain="$1"
  203. [[ "$domain" =~ ^vps-[0-9a-f]*$ ]] && return 0
  204. [[ "$domain" =~ ^vps[0-9]*$ ]] && return 0
  205. return 1
  206. }
  207. vps_connection_check() {
  208. local vps="$1"
  209. ip=$(resolve "$vps") ||
  210. { echo "${DARKRED}no-resolve${NORMAL}"; return 1; }
  211. is-port-open "$ip" "22" </dev/null ||
  212. { echo "${DARKRED}no-port-22-open${NORMAL}"; return 1; }
  213. ssh:open -o ConnectTimeout=10 -o PreferredAuthentications=publickey \
  214. "root@$vps" >/dev/null 2>&1 ||
  215. { echo "${DARKRED}no-ssh-root-access${NORMAL}"; return 1; }
  216. }
  217. vps_check() {
  218. local vps="$1"
  219. vps_connection_check "$vps" </dev/null || return 1
  220. if size=$(
  221. echo "df /srv -h | tail -n +2 | sed -r 's/ +/ /g' | cut -f 5 -d ' ' | cut -f 1 -d %" |
  222. ssh:run "root@$vps" -- bash); then
  223. if [ "$size" -gt "90" ]; then
  224. echo "${DARKRED}above-90%-disk-usage${NORMAL}"
  225. elif [ "$size" -gt "75" ]; then
  226. echo "${DARKYELLOW}above-75%-disk-usage${NORMAL}"
  227. fi
  228. else
  229. echo "${DARKRED}no-size${NORMAL}"
  230. fi </dev/null
  231. compose_content=$(ssh:run "root@$vps" -- cat /opt/apps/myc-deploy/compose.yml </dev/null) ||
  232. { echo "${DARKRED}no-compose${NORMAL}"; return 1; }
  233. echo "$compose_content" | yq -e ".rsync-backup" >/dev/null 2>&1 ||
  234. { echo "${DARKRED}no-backup${NORMAL}"; return 1; }
  235. }
  236. backup:setup-rsync() {
  237. local admin="$1" vps="$2" server="$3" id="$4"
  238. [ -z "${BACKUP_SSH_SERVER}" ] || {
  239. err "Unexpected error: '\$BACKUP_SSH_SERVER' is already set in '$FUNCNAME'."
  240. return 1
  241. }
  242. BACKUP_SSH_OPTIONS=(-o StrictHostKeyChecking=no)
  243. if [[ "$server" == *":"* ]]; then
  244. BACKUP_SSH_OPTIONS+=(-p "${server#*:}")
  245. BACKUP_SSH_SERVER=${server%%:*}
  246. else
  247. BACKUP_SSH_SERVER="$server"
  248. fi
  249. if ! private_key=$(ssh "${BACKUP_SSH_OPTIONS[@]}" \
  250. "$admin"@"${BACKUP_SSH_SERVER}" request-recovery-key "$id"); then
  251. err "Couldn't request a recovery key for '$id' with account '$admin'."
  252. return 1
  253. fi
  254. if ! VPS_TMP_DIR=$(echo "mktemp -d" | ssh:run "root@$vps" -- bash); then
  255. err "Couldn't create a temporary directory on vps"
  256. return 1
  257. fi
  258. cat <<EOF | ssh:run "root@$vps" -- bash || return 1
  259. touch "$VPS_TMP_DIR/recover_key" &&
  260. chmod go-rwx "$VPS_TMP_DIR/recover_key" &&
  261. printf "%s\n" "$private_key" >> "$VPS_TMP_DIR/recover_key"
  262. EOF
  263. BACKUP_SSH_OPTIONS+=(-i "$VPS_TMP_DIR/recover_key" -l rsync)
  264. BACKUP_VPS_TARGET="$vps"
  265. BACKUP_IDENT="$id"
  266. echo "type -p rsync >/dev/null 2>&1 || apt-get install -y rsync </dev/null" |
  267. ssh:run "root@$vps" -- bash || return 1
  268. }
  269. backup:rsync() {
  270. local ssh_options
  271. [ -n "${BACKUP_SSH_SERVER}" ] || {
  272. err "Unexpected error: '\$BACKUP_SSH_SERVER' is not set in 'rsync_exists'."
  273. return 1
  274. }
  275. rsync_options=()
  276. while [[ "$1" == "-"* ]]; do
  277. rsync_options+=("$1")
  278. shift
  279. done
  280. local src="$1" dst="$2"
  281. cat <<EOF | ssh:run "root@${BACKUP_VPS_TARGET}" -- bash
  282. rsync -e "ssh ${BACKUP_SSH_OPTIONS[*]}" \
  283. -azvArH --delete --delete-excluded \
  284. --partial --partial-dir .rsync-partial \
  285. --numeric-ids ${rsync_options[*]} \
  286. "${BACKUP_SSH_SERVER}":/var/mirror/"${BACKUP_IDENT}${src}" "${dst}"
  287. EOF
  288. }
  289. backup:path_exists() {
  290. local src="$1"
  291. [ -n "${BACKUP_SSH_SERVER}" ] || {
  292. err "Unexpected error: '\$BACKUP_SSH_SERVER' is not set in 'rsync_exists'."
  293. return 1
  294. }
  295. cat <<EOF | ssh:run "root@${BACKUP_VPS_TARGET}" -- bash >/dev/null 2>&1
  296. rsync -e "ssh ${BACKUP_SSH_OPTIONS[*]}" \
  297. -nazvArH --numeric-ids \
  298. "${BACKUP_SSH_SERVER}":/var/mirror/"${BACKUP_IDENT}${src}" "/tmp/dummy"
  299. EOF
  300. }
  301. file:vps_backup_recover() {
  302. local admin="$1" server="$2" id="$3" path="$4" vps="$5" vps_path="$6"
  303. backup:rsync "${path}" "${vps_path}" || return 1
  304. if [[ "$path" == *"/" ]]; then
  305. if [ "$path" == "$vps_path"/ ]; then
  306. msg_target="Directory '$path'"
  307. else
  308. msg_target="Directory '$path' -> '$vps_path'"
  309. fi
  310. else
  311. if [ "$path" == "$vps_path" ]; then
  312. msg_target="File '$path'"
  313. else
  314. msg_target="File '$path' -> '$vps_path'"
  315. fi
  316. fi
  317. info "$msg_target was ${GREEN}successfully${NORMAL} restored on $vps."
  318. }
  319. mailcow:vps_backup_recover() {
  320. local admin="$1" server="$2" id="$3" path="$4" vps="$5" vps_path="$6"
  321. if ! compose_yml_files=$(cat <<EOF | ssh:run "root@$vps" -- bash
  322. urn=com.docker.compose.project
  323. docker ps -f "label=\$urn=mailcowdockerized" \
  324. --format="{{.Label \"\$urn.working_dir\"}}/{{.Label \"\$urn.config_files\"}}" |
  325. uniq
  326. EOF
  327. ); then
  328. err "Couldn't get list of running projects"
  329. return 1
  330. fi
  331. stopped_containers=
  332. if [ -n "$compose_yml_files" ]; then
  333. echo "Found running mailcowdockerized containers" >&2
  334. if [[ "$compose_yml_files" == *$'\n'* ]]; then
  335. err "Running containers are confusing, did not find only one mailcowdockerized project."
  336. return 1
  337. fi
  338. if ! echo "[ -e \"$compose_yml_files\" ]" | ssh:run "root@$vps" -- bash ; then
  339. ## For some reason, sometimes $urn.config_files holds an absolute path
  340. compose_yml_files=/${compose_yml_files#*//}
  341. if ! echo "[ -e \"$compose_yml_files\" ]" | ssh:run "root@$vps" -- bash ; then
  342. err "Running containers are confusing, they don't point to an existing docker-compose.yml."
  343. return 1
  344. fi
  345. fi
  346. echo "Containers where launched from '$compose_yml_files'" >&2
  347. COMPOSE_FILE="$compose_yml_files"
  348. ENV_FILE="${COMPOSE_FILE%/*}/.env"
  349. if ! echo "[ -e \"${ENV_FILE}\" ]" | ssh:run "root@$vps" -- bash ; then
  350. err "Running containers are confusing, docker-compose.yml has no '.env' next to it."
  351. return 1
  352. fi
  353. echo "${WHITE}Bringing mailcowdockerized down${NORMAL}"
  354. echo "docker-compose -f \"${COMPOSE_FILE}\" --env-file \"${ENV_FILE}\" down" |
  355. ssh:run "root@$vps" -- bash
  356. stopped_containers=1
  357. fi
  358. if [[ "$path" == "/"* ]]; then
  359. ##
  360. ## Additional intelligence to simple file copy
  361. ##
  362. if [[ "$path" == "/var/lib/docker/volumes/mailcowdockerized_*-vol-1/_data"* ]]; then
  363. volume_name=${path#/var/lib/docker/volumes/}
  364. volume_name=${volume_name%%/*}
  365. volume_dir=${path%%"$volume_name"*}
  366. ## Create volumes if not existent
  367. if ! ssh:run "root@$vps" -- "
  368. [ -d '${volume_dir}' ] ||
  369. docker run --rm -v ${volume_name}:/tmp/dummy docker.0k.io/alpine:3.9
  370. [ -d '${volume_dir}' ]
  371. "; then
  372. err "Couldn't find nor create '${volume_dir}'."
  373. return 1
  374. fi
  375. fi
  376. echo "${WHITE}Sync from backup ${path} to VPS ${vps_path}${NORMAL}" >&2
  377. backup:rsync "${path}" "${vps_path}" || return 1
  378. if [[ "$path" == *"/" ]]; then
  379. if [ "$path" == "$vps_path"/ ]; then
  380. msg_target="Directory '$path'"
  381. else
  382. msg_target="Directory '$path' -> '$vps_path'"
  383. fi
  384. else
  385. if [ "$path" == "$vps_path" ]; then
  386. msg_target="File '$path'"
  387. else
  388. msg_target="File '$path' -> '$vps_path'"
  389. fi
  390. fi
  391. else
  392. ALL_TARGETS=(mailcow postfix rspamd redis crypt vmail{,-attachments} mysql)
  393. if [[ -n "$path" ]]; then
  394. targets=()
  395. bad_targets=()
  396. for target in ${path//,/ }; do
  397. if [[ " ${ALL_TARGETS[*]} " != *" $target "* ]]; then
  398. bad_targets+=("$target")
  399. fi
  400. targets+=("$target")
  401. done
  402. if [ "${#bad_targets[@]}" -gt 0 ]; then
  403. bad_target_msg=$(printf "%s, " "${bad_targets[@]}")
  404. err "Unknown components: ${bad_target_msg%, }. These are allowed components:"
  405. printf " - %s\n" "${ALL_TARGETS[@]}" >&2
  406. return 1
  407. fi
  408. msg_target="Partial mailcow backup"
  409. else
  410. targets=("${ALL_TARGETS[@]}")
  411. msg_target="Full mailcow backup"
  412. fi
  413. for target in "${targets[@]}"; do
  414. case "$target" in
  415. postfix|rspamd|redis|crypt|vmail|vmail-attachments)
  416. volume_name="mailcowdockerized_${target}-vol-1"
  417. volume_dir="/var/lib/docker/volumes/${volume_name}/_data"
  418. if ! backup:path_exists "${volume_dir}/"; then
  419. warn "No '$volume_name' in backup. This might be expected."
  420. continue
  421. fi
  422. ## Create volumes if not existent
  423. if ! ssh:run "root@$vps" -- "
  424. [ -d '${volume_dir}' ] ||
  425. docker run --rm -v ${volume_name}:/tmp/dummy docker.0k.io/alpine:3.9
  426. [ -d '${volume_dir}' ]
  427. "; then
  428. err "Couldn't find nor create '${volume_dir}'."
  429. return 1
  430. fi
  431. echo "${WHITE}Downloading of $volume_name${NORMAL}"
  432. backup:rsync "${volume_dir}/" "${volume_dir}" || return 1
  433. ;;
  434. mailcow)
  435. ## Mailcow git base
  436. COMPOSE_FILE=
  437. for mailcow_dir in /opt/{apps/,}mailcow-dockerized; do
  438. backup:path_exists "${mailcow_dir}/" || continue
  439. ## this possibly change last value
  440. COMPOSE_FILE="$mailcow_dir/docker-compose.yml"
  441. ENV_FILE="$mailcow_dir/.env"
  442. echo "${WHITE}Download of $mailcow_dir${NORMAL}"
  443. backup:rsync "${mailcow_dir}"/ "${mailcow_dir}" || return 1
  444. break
  445. done
  446. if [ -z "$COMPOSE_FILE" ]; then
  447. err "Can't find mailcow base installation path in backup."
  448. return 1
  449. fi
  450. ;;
  451. mysql)
  452. if [ -z "$COMPOSE_FILE" ]; then
  453. ## Mailcow git base
  454. compose_files=()
  455. for mailcow_dir in /opt/{apps/,}mailcow-dockerized; do
  456. ssh:run "root@$vps" -- "[ -e \"$mailcow_dir/docker-compose.yml\" ]" || continue
  457. ## this possibly change last value
  458. compose_files+=("$mailcow_dir/docker-compose.yml")
  459. done
  460. if [ "${#compose_files[@]}" == 0 ]; then
  461. err "No compose file found for mailcow installation."
  462. return 1
  463. elif [ "${#compose_files[@]}" -gt 1 ]; then
  464. err "Multiple compose files for mailcow found:"
  465. for f in "${compose_files[@]}"; do
  466. echo " - $f" >&2
  467. done
  468. echo "Can't decide which to use for mounting mysql container." >&2
  469. return 1
  470. fi
  471. COMPOSE_FILE="${compose_files[0]}"
  472. ENV_FILE="${COMPOSE_FILE%/*}/.env"
  473. if ! ssh:run "root@$vps" -- "[ -e \"${COMPOSE_FILE%/*}/.env\" ]"; then
  474. err "No env file in '$ENV_FILE' found."
  475. return 1
  476. fi
  477. fi
  478. ## Mysql database
  479. echo "${WHITE}Downloading last backup of mysql backups${NORMAL}"
  480. backup:rsync "/var/backups/mysql/" "/var/backups/mysql" || return 1
  481. if ! env_content=$(echo "cat '$ENV_FILE'" | ssh:run "root@$vps" -- bash); then
  482. err "Can't access env file: '$ENV_FILE'."
  483. return 1
  484. fi
  485. root_password=$(printf "%s\n" "$env_content" | grep ^DBROOT= | cut -f 2 -d =)
  486. echo "${WHITE}Bringing mysql-mailcow up${NORMAL}"
  487. if ! image=$(cat <<EOF | ssh:run "root@$vps" -- bash
  488. shyaml get-value services.mysql-mailcow.image < "${COMPOSE_FILE}"
  489. EOF
  490. ); then
  491. err "Failed to get image name of service 'mysql-mailcow' in 'compose.yml'."
  492. return 1
  493. fi
  494. if [ -z "$(ssh:run "root@$vps" -- docker images -q "$image")" ]; then
  495. info "Image '$image' not available, pull it."
  496. if ! ssh:run "root@$vps" -- \
  497. docker-compose -f "${COMPOSE_FILE}" --env-file "${ENV_FILE}" \
  498. pull mysql-mailcow; then
  499. err "Failed to pull image of service 'mysql-mailcow'."
  500. return 1
  501. fi
  502. fi
  503. if ! container_id=$(cat <<EOF | ssh:run "root@$vps" -- bash
  504. echo "[client]
  505. password=$root_password" > "$VPS_TMP_DIR/my.cnf"
  506. docker-compose -f "${COMPOSE_FILE}" --env-file "${ENV_FILE}" \
  507. run -d \
  508. -v "$VPS_TMP_DIR/my.cnf:/root/.my.cnf:ro" \
  509. mysql-mailcow
  510. EOF
  511. ); then
  512. err "Failed to bring up mysql-mailcow"
  513. return 1
  514. fi
  515. START="$SECONDS"
  516. retries=0
  517. timeout=600
  518. while true; do
  519. ((retries++))
  520. echo " waiting for mysql db..." \
  521. "(retry $retries, $(($SECONDS - $START))s elapsed, timeout is ${timeout}s)" >&2
  522. cat <<EOF | ssh:run "root@$vps" -- bash && break
  523. echo "SELECT 1;" | docker exec -i "$container_id" mysql >/dev/null 2>&1
  524. EOF
  525. if (($SECONDS - $START > $timeout)); then
  526. err "Failed to connect to mysql-mailcow."
  527. echo "docker-compose -f \"${COMPOSE_FILE}\" --env-file \"${ENV_FILE}\" down" |
  528. ssh:run "root@$vps" -- bash
  529. return 1
  530. fi
  531. sleep 0.4
  532. done
  533. DBUSER=$(printf "%s\n" "$env_content" | grep ^DBUSER= | cut -f 2 -d =)
  534. DBPASS=$(printf "%s\n" "$env_content" | grep ^DBPASS= | cut -f 2 -d =)
  535. echo "${WHITE}Uploading mysql dump${NORMAL}"
  536. cat <<EOF | ssh:run "root@$vps" -- bash
  537. echo "
  538. DROP DATABASE IF EXISTS mailcow;
  539. CREATE DATABASE mailcow;
  540. GRANT ALL PRIVILEGES ON mailcow.* TO '$DBUSER'@'%' IDENTIFIED BY '$DBPASS';
  541. " | docker exec -i "$container_id" mysql
  542. zcat /var/backups/mysql/mailcow/*.gz | docker exec -i "$container_id" mysql mailcow
  543. EOF
  544. if [ "$?" != 0 ]; then
  545. err "Failed to load mysql dump."
  546. echo "docker-compose -f \"${COMPOSE_FILE}\" --env-file \"${ENV_FILE}\" down" |
  547. ssh:run "root@$vps" -- bash
  548. return 1
  549. fi
  550. echo "${WHITE}Bringing mysql-mailcow down${NORMAL}"
  551. echo "docker-compose -f \"${COMPOSE_FILE}\" --env-file \"${ENV_FILE}\" down" |
  552. ssh:run "root@$vps" -- bash
  553. ;;
  554. *)
  555. err "Unknown component '$target'. Bailing out."
  556. return 1
  557. esac
  558. done
  559. ssh:run "root@$vps" -- "rm -rf '$VPS_TMP_DIR'"
  560. fi
  561. if [ -n "$stopped_containers" ]; then
  562. echo "${WHITE}Starting mailcow${NORMAL}" >&2
  563. echo "docker-compose -f \"${COMPOSE_FILE}\" --env-file \"${ENV_FILE}\" up -d" |
  564. ssh:run "root@$vps" -- bash
  565. fi
  566. info "$msg_target was ${GREEN}successfully${NORMAL} restored on $vps."
  567. }
  568. NTFY_TOPIC_FILE="/etc/ntfy/topics.yml"
  569. subscribe:ntfy:exists() {
  570. local vps="$1"
  571. if ! out=$(echo "[ -f \"$NTFY_TOPIC_FILE\" ] && echo ok || true" | \
  572. ssh:run "root@$vps" -- bash); then
  573. err "Unable to check for existence of '$NTFY_TOPIC_FILE'."
  574. fi
  575. if [ -z "$out" ]; then
  576. err "File '$NTFY_TOPIC_FILE' not found on $vps."
  577. return 1
  578. fi
  579. }
  580. ntfy:rm() {
  581. local channel="$1" topic="$2" vps="$3"
  582. subscribe:ntfy:exists "$vps" || return 1
  583. if ! out=$(echo "yq -i 'del(.[\"$channel\"][] | select(. == \"$TOPIC\"))' \"$NTFY_TOPIC_FILE\"" | \
  584. ssh:run "root@$vps" -- bash); then
  585. err "Failed to remove channel '$channel' from '$NTFY_TOPIC_FILE'."
  586. return 1
  587. fi
  588. info "Channel '$channel' removed from '$NTFY_TOPIC_FILE' on $vps."
  589. ssh:run "root@$vps" -- cat "$NTFY_TOPIC_FILE"
  590. }
  591. ntfy:add() {
  592. local vps="$1"
  593. read-0 channel topic || {
  594. err "Couldn't read CHANNEL and TOPIC arguments."
  595. return 1
  596. }
  597. vps_connection_check "$vps" </dev/null || return 1
  598. subscribe:ntfy:exists "$vps" || return 1
  599. if ! out=$(echo "yq '. | has(\"$channel\")' \"$NTFY_TOPIC_FILE\"" | \
  600. ssh:run "root@$vps" -- bash); then
  601. err "Failed to check if channel '$channel' with topic '$topic' is already in '$NTFY_TOPIC_FILE'."
  602. return 1
  603. fi
  604. if [ "$out" != "true" ]; then
  605. ## Channel does not exist
  606. if ! out=$(echo "yq -i '.[\"$channel\"] = []' \"$NTFY_TOPIC_FILE\"" | \
  607. ssh:run "root@$vps" -- bash); then
  608. err "Failed to create a new channel '$channel' entry in '$NTFY_TOPIC_FILE'."
  609. return 1
  610. fi
  611. else
  612. ## Channel exists
  613. if ! out=$(echo "yq '.[\"$channel\"] | any_c(. == \"$topic\")' \"$NTFY_TOPIC_FILE\"" | \
  614. ssh:run "root@$vps" -- bash); then
  615. err "Failed to check if channel '$channel' with topic '$topic' is already in '$NTFY_TOPIC_FILE'."
  616. return 1
  617. fi
  618. if [ "$out" == "true" ]; then
  619. info "Channel '$channel' with topic '$topic' already exists in '$NTFY_TOPIC_FILE'."
  620. return 0
  621. fi
  622. fi
  623. if ! out=$(echo "yq -i '.[\"$channel\"] += [\"$topic\"]' \"$NTFY_TOPIC_FILE\"" | \
  624. ssh:run "root@$vps" -- bash); then
  625. err "Failed to add channel '$channel' with topic '$topic' to '$NTFY_TOPIC_FILE'."
  626. return 1
  627. fi
  628. info "Channel '$channel' added with topic '$topic' to '$NTFY_TOPIC_FILE' on $vps."
  629. }
  630. NTFY_SERVER="https://ntfy.0k.io"
  631. subscribe:add() {
  632. local vps="$1"
  633. read-0 channel topic || {
  634. err "Couldn't read CHANNEL and TOPIC arguments."
  635. return 1
  636. }
  637. vps_connection_check "$vps" </dev/null || return 1
  638. ntfy:add "$channel" "$topic" "$vps"
  639. }
  640. subscribe:rm() {
  641. local vps="$1"
  642. read-0 channel topic || {
  643. err "Couldn't read CHANNEL and TOPIC arguments."
  644. return 1
  645. }
  646. vps_connection_check "$vps" </dev/null || return 1
  647. ntfy:rm "$channel" "$topic" "$vps"
  648. }
  649. vps_backup_recover() {
  650. local vps="$1" admin server id path rtype force type
  651. read-0 admin server id path rtype force
  652. if [[ "$vps" == *":"* ]]; then
  653. vps_path=${vps#*:}
  654. vps=${vps%%:*}
  655. else
  656. vps_path=
  657. fi
  658. vps_connection_check "$vps" </dev/null || {
  659. err "Failed to access '$vps'."
  660. return 1
  661. }
  662. if type=$(ssh:run "root@$vps" -- vps get-type); then
  663. info "VPS $vps seems to be of ${WHITE}$type${NORMAL} type"
  664. else
  665. warn "Couldn't find type of vps '$vps' (command 'vps get-type' failed on vps)."
  666. fi
  667. if [ -z "$path" ]; then
  668. if [ -n "$vps_path" ]; then
  669. err "You can't provide a VPS with path as destination if you don't provide a path in backup source."
  670. return 1
  671. fi
  672. info "No path provided in backup, so we assume you want ${WHITE}full recovery${NORMAL}."
  673. if [ "$rtype" != "$type" ]; then
  674. if [ -n "$force" ]; then
  675. warn "Backup found is of ${rtype:-unknown} type, while vps is of ${type:-unknown} type."
  676. else
  677. err "Backup found is of ${rtype:-unknown} type, while vps is of ${type:-unknown} type. (use \`\`-f\`\` to force)"
  678. return 1
  679. fi
  680. fi
  681. else
  682. if [ "$path" == "/" ]; then
  683. if [ -z "$vps_path" ]; then
  684. err "Recovery of '/' (full backup files) requires that you provide a vps path also."
  685. return 1
  686. fi
  687. if [ "$vps_path" == "/" ]; then
  688. err "Recovery of '/' (full backup files) requires that you provide" \
  689. "a vps path different from '/' also."
  690. return 1
  691. fi
  692. fi
  693. fi
  694. ## Sets VPS and internal global variable to allow rsync to work
  695. ## from vps to backup server.
  696. backup:setup-rsync "$admin" "$vps" "$server" "$id" || return 1
  697. if [[ "$path" == "/"* ]]; then
  698. if ! backup:path_exists "${path}"; then
  699. err "File or directory '$path' not found in backup."
  700. return 1
  701. fi
  702. if [ -z "$vps_path" ]; then
  703. if [[ "$path" != *"/" ]] && backup:path_exists "${path}"/ ; then
  704. path="$path/"
  705. fi
  706. vps_path=${path%/}
  707. vps_path=${vps_path:-/}
  708. fi
  709. fi
  710. case "$rtype-$type" in
  711. mailcow-*)
  712. ## Supports having $path and $vps_path set or unset, with additional behavior
  713. mailcow:vps_backup_recover "$admin" "$server" "$id" "$path" "$vps" "$vps_path"
  714. ;;
  715. *-*)
  716. if [[ "$path" == "/"* ]]; then
  717. ## For now, will require having $path and $vps_path set, no additional behaviors
  718. file:vps_backup_recover "$admin" "$server" "$id" "$path" "$vps" "$vps_path"
  719. else
  720. if [ -n "$path" ]; then
  721. err "Partial component recover of ${rtype:-unknown} backup type on" \
  722. "${type:-unknown} type VPS is not yet implemented."
  723. return 1
  724. else
  725. err "Full recover of ${rtype:-unknown} backup type on" \
  726. "${type:-unknown} type VPS is not yet implemented."
  727. return 1
  728. fi
  729. fi
  730. ;;
  731. esac
  732. }
  733. vps_install_backup() {
  734. local vps="$1" admin server
  735. vps_connection_check "$vps" </dev/null || return 1
  736. read-0 admin server
  737. if ! type=$(ssh:run "root@$vps" -- vps get-type); then
  738. err "Could not get type."
  739. return 1
  740. fi
  741. if ! out=$(ssh:run "root@$vps" -- vps install backup "$server" 2>&1); then
  742. err "Command 'vps install backup $server' on $vps failed:"
  743. echo "$out" | prefix " ${DARKGRAY}|${NORMAL} " >&2
  744. return 1
  745. fi
  746. ## Format of output:
  747. ##
  748. ## II Entry for service rsync-backup is already present in '/opt/apps/myc-deploy/compose.yml'.
  749. ## II You can run this following command from an host having admin access to core-07.0k.io:
  750. ## (Or send it to a backup admin of core-07.0k.io)
  751. ## ssh -p 10023 myadmin@core-07.0k.io ssh-key add 'ssh-rsa AAAAAAAD...QCJ\
  752. ## 8HH6pVgEpu1twyxpr9xTt7eh..WaJdgPoxmiEwGfjMMNGxs39ggOTKUuSFSmOv8TiA1fzY\
  753. ## s85hF...dKP1qByJU1k= compose@odoo.sikle.fr'
  754. key="ssh-rsa ${out##*\'ssh-rsa }" ## remove everything before last "'ssh-rsa"
  755. key="${key%\'*}" ## remove everything after last '
  756. if ! [[ "$key" =~ ^"ssh-rsa "[a-zA-Z0-9/+=]+" "[a-zA-Z0-9._-]+"@"[a-zA-Z0-9._-]+$ ]]; then
  757. err "Unexpected output from 'vps install backup $server'. Can't find key."
  758. echo "$out" | prefix " ${GRAY}|$NORMAL " >&2
  759. echo " Extracted key:" >&2
  760. echo "$key" | prefix " ${GRAY}|$NORMAL " >&2
  761. return 1
  762. fi
  763. if [ "$type" == "compose" ]; then
  764. if ! ssh:run "root@$vps" -- \
  765. docker exec myc_cron_1 \
  766. cat /etc/cron.d/rsync-backup >/dev/null 2>&1; then
  767. ssh:run "root@$vps" -- compose --debug up || {
  768. err "Command 'compose --debug up' failed."
  769. return 1
  770. }
  771. if ! ssh:run "root@$vps" -- \
  772. docker exec myc_cron_1 \
  773. cat /etc/cron.d/rsync-backup >/dev/null 2>&1; then
  774. err "Launched 'compose up' successfully but ${YELLOW}cron${NORMAL} container is not setup as expected."
  775. echo " Was waiting for existence of '/etc/cron.d/rsync-backup' in it." >&2
  776. return 1
  777. fi
  778. fi
  779. fi
  780. dest="$server"
  781. dest="${dest%/*}"
  782. ssh_options=()
  783. if [[ "$dest" == *":"* ]]; then
  784. port="${dest##*:}"
  785. dest="${dest%%:*}"
  786. ssh_options=(-p "$port")
  787. else
  788. port=""
  789. dest="${dest%%:*}"
  790. fi
  791. cmd=(ssh "${ssh_options[@]}" "$admin"@"$dest" ssh-key add "$key")
  792. echo "${WHITE}Launching:${NORMAL} ${cmd[@]}"
  793. "${cmd[@]}" || {
  794. err "Failed add key to backup server '$dest'."
  795. return 1
  796. }
  797. echo "${WHITE}Launching backup${NORMAL} from '$vps'"
  798. ssh:run "root@$vps" -- vps backup || {
  799. err "First backup failed to run."
  800. return 1
  801. }
  802. echo "Backup is ${GREEN}up and running${NORMAL}."
  803. }
  804. vps_update() {
  805. local vps="$1"
  806. vps_connection_check "$vps" || return 1
  807. ssh:run "root@$vps" -- myc-update </dev/null
  808. }
  809. vps_bash() {
  810. local vps="$1"
  811. vps_connection_check "$vps" </dev/null || return 1
  812. ssh:run "root@$vps" -- bash
  813. }
  814. vps_mux() {
  815. local fn="$1" vps_done VPS max_size vps
  816. shift
  817. VPS=($(printf "%s\n" "$@" | sort))
  818. max_size=0
  819. declare -A vps_done;
  820. new_vps=()
  821. for name in "${VPS[@]}"; do
  822. [ -n "${vps_done[$name]}" ] && {
  823. warn "duplicate vps '$name' provided. Ignoring."
  824. continue
  825. }
  826. vps_done["$name"]=1
  827. new_vps+=("$name")
  828. size_name="${#name}"
  829. [ "$max_size" -lt "${size_name}" ] &&
  830. max_size="$size_name"
  831. done
  832. settmpdir "_0KM_TMP_DIR"
  833. cat > "$_0KM_TMP_DIR/code"
  834. for vps in "${new_vps[@]}"; do
  835. label=$(printf "%-${max_size}s" "$vps")
  836. (
  837. {
  838. {
  839. "$fn" "$vps" < "$_0KM_TMP_DIR/code"
  840. } 3>&1 1>&2 2>&3 | sed -r "s/^/$DARKCYAN$label$NORMAL $DARKRED\!$NORMAL /g"
  841. set_errlvl "${PIPESTATUS[0]}"
  842. } 3>&1 1>&2 2>&3 | sed -r "s/^/$DARKCYAN$label$NORMAL $DARKGRAY\|$NORMAL /g"
  843. set_errlvl "${PIPESTATUS[0]}"
  844. ) &
  845. done
  846. wait
  847. }
  848. [ "$SOURCED" ] && return 0
  849. ##
  850. ## Command line processing
  851. ##
  852. cmdline.spec.gnu
  853. cmdline.spec.reporting
  854. cmdline.spec.gnu vps-setup
  855. cmdline.spec::cmd:vps-setup:run() {
  856. : :posarg: HOST 'Target host to check/fix ssh-access'
  857. : :optfla: --force,-f "Will force domain name change, even if
  858. current hostname was not recognized as
  859. an ovh domain name. "
  860. depends sshpass shyaml
  861. KEY_PATH="ssh-access.public-keys"
  862. local keys=$(config get-value -y "ssh-access.public-keys") || true
  863. if [ -z "$keys" ]; then
  864. err "No ssh publickeys configured in config file."
  865. echo " Looking for keys in ${WHITE}${KEY_PATH}${NORMAL}" \
  866. "in config file." >&2
  867. config:exists --message 2>&1 | prefix " "
  868. if [ "${PIPESTATUS[0]}" == "0" ]; then
  869. echo " Config file found in $(config:filename)"
  870. fi
  871. return 1
  872. fi
  873. local tkey=$(e "$keys" | shyaml get-type)
  874. if [ "$tkey" != "sequence" ]; then
  875. err "Value type of ${WHITE}${KEY_PATH}${NORMAL} unexpected (is $tkey, expecting sequence)."
  876. echo " Check content of $(config:filename), and make sure to use a sequence." >&2
  877. return 1
  878. fi
  879. local IP NAME keys host_pass_connected
  880. if ! IP=$(resolve "$HOST"); then
  881. err "'$HOST' name unresolvable."
  882. exit 1
  883. fi
  884. NAME="$HOST"
  885. if [ "$IP" != "$HOST" ]; then
  886. NAME="$HOST ($IP)"
  887. fi
  888. if ! is-port-open "$IP" "22"; then
  889. err "$NAME unreachable or port 22 closed."
  890. exit 1
  891. fi
  892. debug "Host $IP's port 22 is open."
  893. if ! host_pass_connected=$(ssh:open-try \
  894. {root,debian}@"$HOST"); then
  895. err "Could not connect to {root,debian}@$HOST with publickey nor password."
  896. exit 1
  897. fi
  898. read-0a host password <<<"$host_pass_connected"
  899. sudo_if_necessary=
  900. if [ "$password" -o "${host%%@*}" != "root" ]; then
  901. if ! ssh:run "$host" -- sudo -n true >/dev/null 2>&1; then
  902. err "Couldn't do a password-less sudo from $host."
  903. echo " This is not yet supported."
  904. exit 1
  905. else
  906. sudo_if_necessary=sudo
  907. fi
  908. fi
  909. SUPPORTED_KEY_TYPE=(ssh-rsa ssh-ed25519)
  910. Section Checking access
  911. while read-0 key; do
  912. prefix="${key%% *}"
  913. if ! [[ " ${SUPPORTED_KEY_TYPE[*]} " == *" $prefix "* ]]; then
  914. err "Unsupported key:"$'\n'"$key"
  915. echo " Please use only key of the following type:" >&2
  916. printf " - %s\n" "${SUPPORTED_KEY_TYPE[@]}" >&2
  917. return 1
  918. fi
  919. label="${key##* }"
  920. Elt "considering adding key ${DARKYELLOW}$label${NORMAL}"
  921. dest="/root/.ssh/authorized_keys"
  922. if ssh:run "$host" -- $sudo_if_necessary grep "\"$key\"" "$dest" >/dev/null 2>&1 </dev/null; then
  923. print_info "already present"
  924. print_status noop
  925. Feed
  926. else
  927. if echo "$key" | ssh:run "$host" -- $sudo_if_necessary tee -a "$dest" >/dev/null; then
  928. print_info added
  929. else
  930. echo
  931. Feedback failure
  932. return 1
  933. fi
  934. Feedback success
  935. fi
  936. done < <(e "$keys" | shyaml get-values-0)
  937. Section Checking ovh hostname file
  938. Elt "Checking /etc/ovh-hostname"
  939. if ! ssh:run "$host" -- $sudo_if_necessary [ -e "/etc/ovh-hostname" ]; then
  940. print_info "creating"
  941. ssh:run "$host" -- $sudo_if_necessary cp /etc/hostname /etc/ovh-hostname
  942. ovhname=$(ssh:run "$host" -- $sudo_if_necessary cat /etc/ovh-hostname)
  943. Elt "Checking /etc/ovh-hostname: $ovhname"
  944. Feedback || return 1
  945. else
  946. ovhname=$(ssh:run "$host" -- $sudo_if_necessary cat /etc/ovh-hostname)
  947. Elt "Checking /etc/ovh-hostname: $ovhname"
  948. print_info "already present"
  949. print_status noop
  950. Feed
  951. fi
  952. if ! is_ovh_domain_name "$HOST" && ! str_is_ipv4 "$HOST"; then
  953. Section Checking hostname
  954. Elt "Checking /etc/hostname..."
  955. old_etc_hostname="$(ssh:run "$host" -- $sudo_if_necessary cat /etc/hostname)"
  956. if [ "$old_etc_hostname" != "$HOST" ]; then
  957. Elt "/etc/hostname is '$old_etc_hostname'"
  958. if is_ovh_hostname "$old_etc_hostname" || [ -n "$opt_force" ]; then
  959. Elt "Hostname '$old_etc_hostname' --> '$HOST'"
  960. print_info "creating"
  961. echo "$HOST" | ssh:run "$host" -- $sudo_if_necessary tee /etc/hostname >/dev/null &&
  962. ssh:run "$host" -- $sudo_if_necessary hostname "$HOST"
  963. Feedback || return 1
  964. else
  965. Elt "Hostname '$old_etc_hostname' isn't an ovh domain"
  966. print_info "no change"
  967. print_status noop
  968. Feed
  969. warn "Domain name was not changed because it was already set"
  970. echo " (use \`-f\` or \`--force\`) to force domain name change to $HOST." >&2
  971. fi
  972. else
  973. print_info "already set"
  974. print_status noop
  975. Feed
  976. fi
  977. Elt "Checking consistency between /etc/hostname and \`hostname\`..."
  978. etc_hostname="$(ssh:run "$host" -- $sudo_if_necessary cat /etc/hostname)"
  979. transient_hostname="$(ssh:run "$host" -- $sudo_if_necessary hostname)"
  980. if [ "$etc_hostname" != "$transient_hostname" ]; then
  981. print_info "change"
  982. ssh:run "$host" -- $sudo_if_necessary hostname "$etc_hostname"
  983. Feedback || return 1
  984. else
  985. print_info "consistent"
  986. print_status noop
  987. Feed
  988. fi
  989. else
  990. info "Not changing domain as '$HOST' doesn't seem to be final domain."
  991. fi
  992. }
  993. cmdline.spec.gnu vps-check
  994. cmdline.spec::cmd:vps-check:run() {
  995. : :posarg: [VPS...] 'Target host(s) to check'
  996. echo "" |
  997. vps_mux vps_check "${VPS[@]}"
  998. }
  999. cmdline.spec.gnu vps-install
  1000. cmdline.spec::cmd:vps-install:run() {
  1001. :
  1002. }
  1003. cmdline.spec.gnu backup
  1004. cmdline.spec:vps-install:cmd:backup:run() {
  1005. : :posarg: BACKUP_TARGET 'Backup target.
  1006. (ie: myadmin@backup.domain.org:10023/256)'
  1007. : :posarg: [VPS...] 'Target host(s) to check'
  1008. if [ "${#VPS[@]}" == 0 ]; then
  1009. warn "VPS list provided in command line is empty. Nothing will be done."
  1010. return 0
  1011. fi
  1012. if ! [[ "$BACKUP_TARGET" == *"@"* ]]; then
  1013. err "Missing admin account identifier in backup target."
  1014. echo " Have you forgottent to specify an account, ie 'myadmin@<MYBACKUP_SERVER>' ?)"
  1015. return 1
  1016. fi
  1017. admin=${BACKUP_TARGET%%@*}
  1018. server=${BACKUP_TARGET#*@}
  1019. p0 "$admin" "$server" |
  1020. vps_mux vps_install_backup "${VPS[@]}"
  1021. }
  1022. cmdline.spec.gnu vps-backup
  1023. cmdline.spec::cmd:vps-backup:run() {
  1024. :
  1025. }
  1026. cmdline.spec.gnu ls
  1027. cmdline.spec:vps-backup:cmd:ls:run() {
  1028. : :posarg: BACKUP_ID 'Backup id.
  1029. (ie: myadmin@backup.domain.org:10023)'
  1030. if ! [[ "$BACKUP_ID" == *"@"* ]]; then
  1031. err "Missing admin account identifier in backup id."
  1032. echo " Have you forgottent to specify an admin account ?" \
  1033. "ie 'myadmin@<MYBACKUP_SERVER>#<BACKUP_IDENT>' ?)"
  1034. return 1
  1035. fi
  1036. id=${BACKUP_ID##*#}
  1037. BACKUP_TARGET=${BACKUP_ID%#*}
  1038. admin=${BACKUP_TARGET%%@*}
  1039. server=${BACKUP_TARGET#*@}
  1040. ## XXXvlab: in this first implementation we expect to have access
  1041. ## to the server main ssh port 22, so we won't use the provided port.
  1042. ssh_options=()
  1043. if [[ "$server" == *":"* ]]; then
  1044. ssh_options+=(-p "${server#*:}")
  1045. server=${server%%:*}
  1046. fi
  1047. ssh "${ssh_options[@]}" "$admin"@"$server" ssh-key ls
  1048. }
  1049. cmdline.spec.gnu recover
  1050. cmdline.spec:vps-backup:cmd:recover:run() {
  1051. : :posarg: BACKUP_ID 'Backup id.
  1052. (ie: myadmin@backup.domain.org:10023#mx.myvps.org
  1053. myadmin@ark-01.org#myid:/a/path
  1054. admin@ark-02.io#myid:myqsl,mailcow)'
  1055. : :posarg: VPS_PATH 'Target host(s) to check.
  1056. (ie: myvps.com
  1057. myvps.com:/a/path)'
  1058. : :optval: --date,-D '"last", or label of version to recover. (Default: "last").'
  1059. : :optfla: --force,-f 'Will allow you to bypass some checks.'
  1060. if ! [[ "$BACKUP_ID" == *"@"* ]]; then
  1061. err "Missing admin account identifier in backup id."
  1062. echo " Have you forgottent to specify an admin account ?" \
  1063. "ie 'myadmin@<MYBACKUP_SERVER>#<BACKUP_IDENT>' ?)"
  1064. return 1
  1065. fi
  1066. if ! [[ "$BACKUP_ID" == *"@"*"#"* ]]; then
  1067. err "Missing backup label identifier in backup id."
  1068. echo " Have you forgottent to specify a backup label identifier ?" \
  1069. "ie 'myadmin@<MYBACKUP_SERVER>#<BACKUP_IDENT>' ?)"
  1070. return 1
  1071. fi
  1072. id_path=${BACKUP_ID#*#}
  1073. if [[ "$id_path" == *":"* ]]; then
  1074. id=${id_path%%:*}
  1075. path=${id_path#*:}
  1076. else
  1077. id="$id_path"
  1078. path=
  1079. fi
  1080. BACKUP_TARGET=${BACKUP_ID%#*}
  1081. admin=${BACKUP_TARGET%%@*}
  1082. server=${BACKUP_TARGET#*@}
  1083. ssh_options=()
  1084. if [[ "$server" == *":"* ]]; then
  1085. ssh_options+=(-p "${server#*:}")
  1086. ssh_server=${server%%:*}
  1087. fi
  1088. BACKUP_PATH="/srv/datastore/data/rsync-backup-target/var/mirror"
  1089. if ! content=$(ssh:run "$admin"@"${ssh_server}" "${ssh_options[@]}" -- ssh-key ls 2>/dev/null); then
  1090. err "Access denied to '$admin@${server}'."
  1091. return 1
  1092. fi
  1093. idents=$(echo "$content" | sed -r "s/"$'\e'"\[[0-9]+(;[0-9]+)*m//g" | cut -f 2 -d " ")
  1094. if ! [[ $'\n'"$idents"$'\n' == *$'\n'"$id"$'\n'* ]]; then
  1095. err "Given backup id '$id' not found in $admin@${server}'s idents."
  1096. return 1
  1097. fi
  1098. rtype=$(ssh:run "$admin"@"${ssh_server}" "${ssh_options[@]}" -- ssh-key get-type "$id" ) &&
  1099. info "Backup archive matches ${WHITE}${rtype}${NORMAL} type"
  1100. p0 "$admin" "$server" "$id" "$path" "$rtype" "$opt_force" |
  1101. vps_backup_recover "${VPS_PATH}"
  1102. }
  1103. cmdline.spec.gnu vps-update
  1104. cmdline.spec::cmd:vps-update:run() {
  1105. : :posarg: [VPS...] 'Target host to check'
  1106. echo "" |
  1107. vps_mux vps_update "${VPS[@]}"
  1108. }
  1109. cmdline.spec.gnu vps-mux
  1110. cmdline.spec::cmd:vps-mux:run() {
  1111. : :posarg: [VPS...] 'Target host(s) to check'
  1112. cat | vps_mux vps_bash "${VPS[@]}"
  1113. }
  1114. cmdline.spec.gnu vps-space
  1115. cmdline.spec::cmd:vps-space:run() {
  1116. : :posarg: [VPS...] 'Target host(s) to check'
  1117. echo "df /srv -h | tail -n +2 | sed -r 's/ +/ /g' | cut -f 2-5 -d ' '" |
  1118. vps_mux vps_bash "${VPS[@]}"
  1119. }
  1120. cmdline.spec.gnu vps-stats
  1121. cmdline.spec::cmd:vps-stats:run() {
  1122. : :posarg: [VPS...] 'Target host(s) to get stats'
  1123. : :optfla: --follow,-f 'Refresh graph every 2m'
  1124. : :optval: --timespan,-t 'timespan START[..END]'
  1125. : :optval: --resource,-r 'resource(s) separated with a comma'
  1126. : :optval: --interval,-i 'refersh interval (default: 60s)'
  1127. local opts_rrdfetch=( -a )
  1128. if [ -n "${opt_timespan}" ]; then
  1129. start=${opt_timespan%\.\.*}
  1130. opts_rrdfetch+=(-s "$start")
  1131. if [ "$start" != "${opt_timespan}" ]; then
  1132. end=${opt_timespan#*..}
  1133. opts_rrdfetch+=(-e "$end")
  1134. fi
  1135. fi
  1136. local resources=(c.memory c.network load_avg)
  1137. if [ -n "${opt_resource}" ]; then
  1138. resources=(${opt_resource//,/ })
  1139. fi
  1140. local not_found=()
  1141. for resource in "${resources[@]}"; do
  1142. if ! fn.exists "graph:def:$resource"; then
  1143. not_found+=("$resource")
  1144. fi
  1145. done
  1146. if [[ "${#not_found[@]}" -gt 0 ]]; then
  1147. not_found_msg=$(printf "%s, " "${not_found[@]}")
  1148. not_found_msg=${not_found_msg%, }
  1149. err "Unsupported resource(s) provided: ${not_found_msg}"
  1150. echo " resource must be one-of:" >&2
  1151. declare -F | egrep 'graph:def:[a-zA-Z_.]+$' | cut -f 3- -d " " | cut -f 3- -d ":" | prefix " - " >&2
  1152. return 1
  1153. fi
  1154. if [ "${#VPS[@]}" == 0 ]; then
  1155. err "You must provide a VPS list as positional arguments"
  1156. return 1
  1157. fi
  1158. include cache
  1159. if [ -z "$VAR_DIR" ]; then
  1160. err "Unset \$VAR_DIR, can't downlowd rrd graph"
  1161. return 1
  1162. fi
  1163. mkdir -p "$VAR_DIR/rrd"
  1164. if ! [ -d "$VAR_DIR/rrd" ]; then
  1165. err "Invalid \$VAR_DIR: '$VAR_DIR/rrd' is not a directory"
  1166. return 1
  1167. fi
  1168. (
  1169. for vps in "${VPS[@]}"; do
  1170. (
  1171. {
  1172. {
  1173. ssh:open "root@$vps" 2>/dev/null || {
  1174. err "Can't open connection $vps."
  1175. return 1
  1176. }
  1177. while true; do
  1178. if ssh:run "root@$vps" -- "[ -d '/var/lib/vps/rrd' ]"; then
  1179. echo "${WHITE}Collecting stats${NORMAL}..."
  1180. {
  1181. {
  1182. ssh:rsync "root@$vps:/var/lib/vps/rrd/" "${VAR_DIR}/rrd/${vps}"
  1183. } 3>&1 1>&2 2>&3 | prefix " ${DARKRED}\!${NORMAL} "
  1184. set_errlvl "${PIPESTATUS[0]}"
  1185. } 3>&1 1>&2 2>&3 | prefix " ${GRAY}|${NORMAL} "
  1186. echo " ${GRAY}..${NORMAL} ${DARKGREEN}done${NORMAL} collecting stats"
  1187. else
  1188. warn "No stats found. Did you run 'myc-update' on the vps ?."
  1189. fi
  1190. [ -z "$opt_follow" ] && break
  1191. echo "${WHITE}Sleeping ${DARKYELLOW}${opt_interval:-60}${NORMAL}s..."
  1192. sleep "${opt_interval:-60}"
  1193. echo " ${GRAY}..${NORMAL} ${DARKGREEN}done${NORMAL} sleeping"
  1194. done
  1195. } 3>&1 1>&2 2>&3 | prefix " ${DARKRED}\!${GRAY} collect(${DARKCYAN}$vps${GRAY})${NORMAL} "
  1196. set_errlvl "${PIPESTATUS[0]}"
  1197. } 3>&1 1>&2 2>&3 | prefix " ${GRAY}| collect(${DARKCYAN}$vps${GRAY})${NORMAL} " >&2
  1198. ) &
  1199. done
  1200. wait
  1201. ) &
  1202. collect_pid="$!"
  1203. if [ -z "$opt_follow" ]; then
  1204. echo "${WHITE}Fetching last stats${NORMAL}${GRAY}..${NORMAL}" >&2
  1205. wait
  1206. echo " ${GRAY}..${DARKGREEN} done${NORMAL} fetching stats" >&2
  1207. else
  1208. collect_end_msg=" ${GRAY}..${NORMAL} ${DARKGREEN}stop${NORMAL} collecting daemon (pid: ${DARKYELLOW}$collect_pid${NORMAL})"
  1209. trap_add EXIT \
  1210. "printf '%s\n' \"$collect_end_msg\" && kill $collect_pid"
  1211. echo "${WHITE}Start collecting daemon${NORMAL} (pid: ${DARKYELLOW}$collect_pid${NORMAL}) ${GRAY}..${NORMAL}" >&2
  1212. fi
  1213. ( depends gnuplot ) || {
  1214. echo ""
  1215. echo " Gnuplot is required to display graphs..." \
  1216. "You might want to try to install ${WHITE}gnuplot${NORMAL} with:"
  1217. echo ""
  1218. echo " apt install gnuplot"
  1219. echo ""
  1220. return 1
  1221. } >&2
  1222. ( depends rrdtool ) || {
  1223. echo ""
  1224. echo " Rrdtool is required to display graphs..." \
  1225. "You might want to try to install ${WHITE}rrdtool${NORMAL} with:"
  1226. echo ""
  1227. echo " apt install rrdtool"
  1228. echo ""
  1229. return 1
  1230. } >&2
  1231. export GNUTERM=qt
  1232. ## rrdtool fetch will use comma for floating point depending on some locals !
  1233. export LC_ALL=C
  1234. exec {PFD}> >(exec gnuplot 2>/dev/null)
  1235. gnuplot_pid="$!"
  1236. if [ -z "$opt_follow" ]; then
  1237. echo "${WHITE}Draw gnuplot graph${GRAY}..${NORMAL}" >&2
  1238. else
  1239. gnuplot_end_msg=" ${GRAY}..${NORMAL} ${DARKGREEN}stop${NORMAL} gnuplot process (pid: $gnuplot_pid)"
  1240. trap_add EXIT \
  1241. "printf '%s\n' \"$gnuplot_end_msg\" && kill $gnuplot_pid"
  1242. echo "${WHITE}Start gnuplot process${NORMAL} (pid: $gnuplot_pid) ${GRAY}..${NORMAL}" >&2
  1243. fi
  1244. echo "set term qt noraise replotonresize" >&$PFD
  1245. while true; do
  1246. {
  1247. i=0
  1248. data_start_ts=
  1249. data_stop_ts=
  1250. for resource in "${resources[@]}"; do
  1251. for vps in "${VPS[@]}"; do
  1252. ((i++))
  1253. {
  1254. {
  1255. rrd_vps_path="$VAR_DIR/rrd/$vps"
  1256. if [ -d "$rrd_vps_path" ]; then
  1257. graph:def:"${resource}" "$vps" "$i" "${opts_rrdfetch[@]}"
  1258. else
  1259. warn "No data yet, ignoring..."
  1260. fi
  1261. } 3>&1 1>&2 2>&3 | prefix " ${DARKRED}\!${GRAY} graph(${DARKCYAN}$vps${GRAY}:${WHITE}$resource${NORMAL})${NORMAL} "
  1262. set_errlvl "${PIPESTATUS[0]}"
  1263. } 3>&1 1>&2 2>&3 || continue 1
  1264. done
  1265. done
  1266. } >&$PFD
  1267. if [ -z "$opt_follow" ]; then
  1268. echo " ${GRAY}..${DARKGREEN} done${NORMAL} gnuplot graphing" >&2
  1269. break
  1270. else
  1271. {
  1272. echo "${WHITE}Sleeping ${DARKYELLOW}${opt_interval:-60}${NORMAL}s..."
  1273. sleep "${opt_interval:-60}"
  1274. echo " ${GRAY}..${NORMAL} ${DARKGREEN}done${NORMAL} sleeping"
  1275. } | prefix " ${GRAY}| gnuplot:${NORMAL} " >&2
  1276. fi
  1277. done
  1278. if [ -n "$opt_follow" ]; then
  1279. echo "Waiting for child process to finish.." >&2
  1280. wait
  1281. echo " ..done" >&2
  1282. else
  1283. echo "pause mouse close" >&$PFD
  1284. fi
  1285. }
  1286. graph:def:c.memory() {
  1287. local vps="$1" i="$2"
  1288. shift 2
  1289. local opts_rrdfetch=("$@")
  1290. local resource="memory"
  1291. rrd_vps_path="$VAR_DIR/rrd/$vps"
  1292. [ -d "$rrd_vps_path/containers" ] || {
  1293. warn "No containers data yet for vps '$vps'... Ignoring"
  1294. return 0
  1295. }
  1296. containers=(
  1297. $(
  1298. cd "$rrd_vps_path/containers";
  1299. find -maxdepth 3 -mindepth 3 -name "${resource}.rrd" -type f |
  1300. sed -r 's%^./([^/]+/[^/]+)/[^/]+.rrd$%\1%g'
  1301. )
  1302. )
  1303. gnuplot_line_config=(
  1304. "set term qt $i title \"$vps $resource\" replotonresize noraise"
  1305. "set title '$vps'"
  1306. "set xdata time"
  1307. "set timefmt '%s'"
  1308. "set ylabel '$resource Usage'"
  1309. "set format y '%s'"
  1310. "set ytics format ' %g'"
  1311. "set mouse mouseformat 6"
  1312. "set yrange [0:*] "
  1313. "set border behind"
  1314. )
  1315. printf "%s\n" "${gnuplot_line_config[@]}"
  1316. first=1
  1317. for container in "${containers[@]}"; do
  1318. rrdfetch_cmd="'< rrdtool fetch \"$rrd_vps_path/containers/$container/$resource.rrd\""
  1319. rrdfetch_cmd+=" AVERAGE ${opts_rrdfetch[*]} | \\"$'\n'
  1320. rrdfetch_cmd+=" tail -n +2 | \\"$'\n'
  1321. rrdfetch_cmd+=" egrep -v \"^$\" | sed -r \"s/ -?nan/ -/g;s/^([0-9]+): /\\1 /g\"'"
  1322. rrdfetch_cmd_bash=$(eval echo "${rrdfetch_cmd}")
  1323. rrdfetch_cmd_bash=${rrdfetch_cmd_bash#< }
  1324. first_ts=
  1325. first_ts=$(eval "$rrdfetch_cmd_bash" | head -n 1 | cut -f 1 -d " ")
  1326. if [ -z "$first_ts" ]; then
  1327. warn "No data for $container on vps $vps, skipping..."
  1328. continue
  1329. fi
  1330. last_ts=$(eval "$rrdfetch_cmd_bash" | tail -n 1 | cut -f 1 -d " ")
  1331. if [[ -z "$data_start_ts" ]] || [[ "$data_start_ts" > "$first_ts" ]]; then
  1332. data_start_ts="$first_ts"
  1333. fi
  1334. if [[ -z "$data_stop_ts" ]] || [[ "$data_stop_ts" < "$last_ts" ]]; then
  1335. data_stop_ts="$last_ts"
  1336. fi
  1337. if [ -n "$first" ]; then
  1338. first=
  1339. echo "plot \\"
  1340. else
  1341. echo ", \\"
  1342. fi
  1343. container="${container//\'/}"
  1344. container="${container//@/\\@}"
  1345. echo -n " ${rrdfetch_cmd} u 1:((\$3 - \$2)/1000000000) w lines title '${container//_/\\_}'"
  1346. done
  1347. echo
  1348. }
  1349. graph:def:c.network() {
  1350. local vps="$1" i="$2"
  1351. shift 2
  1352. local opts_rrdfetch=("$@")
  1353. local resource="network"
  1354. rrd_vps_path="$VAR_DIR/rrd/$vps"
  1355. [ -d "$rrd_vps_path/containers" ] || {
  1356. warn "No containers data yet for vps '$vps'... Ignoring"
  1357. return 0
  1358. }
  1359. containers=(
  1360. $(
  1361. cd "$rrd_vps_path/containers";
  1362. find -maxdepth 3 -mindepth 3 -name "${resource}.rrd" -type f |
  1363. sed -r 's%^./([^/]+/[^/]+)/[^/]+.rrd$%\1%g'
  1364. )
  1365. )
  1366. gnuplot_line_config=(
  1367. "set term qt $i title \"$vps $resource\" replotonresize noraise"
  1368. "set title '$vps'"
  1369. "set xdata time"
  1370. "set timefmt '%s'"
  1371. "set ylabel '$resource Usage'"
  1372. "set format y '%s'"
  1373. "set ytics format ' %.2f MiB/s'"
  1374. "set mouse mouseformat 6"
  1375. "set yrange [0:*] "
  1376. "set border behind"
  1377. )
  1378. printf "%s\n" "${gnuplot_line_config[@]}"
  1379. first=1
  1380. for container in "${containers[@]}"; do
  1381. rrdfetch_cmd="'< rrdtool fetch \"$rrd_vps_path/containers/$container/$resource.rrd\""
  1382. rrdfetch_cmd+=" AVERAGE ${opts_rrdfetch[*]} | \\"$'\n'
  1383. rrdfetch_cmd+=" tail -n +2 | \\"$'\n'
  1384. rrdfetch_cmd+=" egrep -v \"^$\" | sed -r \"s/ -?nan/ -/g;s/^([0-9]+): /\\1 /g\"'"
  1385. rrdfetch_cmd_bash=$(eval echo "${rrdfetch_cmd}")
  1386. rrdfetch_cmd_bash=${rrdfetch_cmd_bash#< }
  1387. first_ts=
  1388. first_ts=$(eval "$rrdfetch_cmd_bash" | head -n 1 | cut -f 1 -d " ")
  1389. if [ -z "$first_ts" ]; then
  1390. warn "No data for $container on vps $vps, skipping..."
  1391. continue
  1392. fi
  1393. last_ts=$(eval "$rrdfetch_cmd_bash" | tail -n 1 | cut -f 1 -d " ")
  1394. if [[ -z "$data_start_ts" ]] || [[ "$data_start_ts" > "$first_ts" ]]; then
  1395. data_start_ts="$first_ts"
  1396. fi
  1397. if [[ -z "$data_stop_ts" ]] || [[ "$data_stop_ts" < "$last_ts" ]]; then
  1398. data_stop_ts="$last_ts"
  1399. fi
  1400. if [ -n "$first" ]; then
  1401. first=
  1402. echo "plot \\"
  1403. else
  1404. echo ", \\"
  1405. fi
  1406. container="${container//\'/}"
  1407. container="${container//@/\\@}"
  1408. echo -n " ${rrdfetch_cmd} u 1:((\$3 / 1024) / 1024) w lines title '${container//_/\\_}'"
  1409. done
  1410. echo
  1411. }
  1412. graph:def:load_avg() {
  1413. local vps="$1" i="$2"
  1414. shift 2
  1415. local opts_rrdfetch=("$@")
  1416. rrd_vps_path="$VAR_DIR/rrd/$vps"
  1417. [ -f "$rrd_vps_path/$resource.rrd" ] || {
  1418. warn "No containers data yet for vps '$vps'... Ignoring"
  1419. return 0
  1420. }
  1421. gnuplot_line_config=(
  1422. "set term qt $i title \"$vps $resource\" replotonresize noraise"
  1423. "set title '$vps'"
  1424. "set xdata time"
  1425. "set timefmt '%s'"
  1426. "set ylabel '${resource//_/\\_} Usage'"
  1427. "set format y '%s'"
  1428. "set ytics format '%g'"
  1429. "set mouse mouseformat 6"
  1430. "set yrange [0:*] "
  1431. "set border behind"
  1432. )
  1433. printf "%s\n" "${gnuplot_line_config[@]}"
  1434. first=1
  1435. for value in 1m:2 5m:3 15m:4; do
  1436. label="${value%:*}"
  1437. col_num="${value#*:}"
  1438. rrdfetch_cmd="'< rrdtool fetch \"$rrd_vps_path/$resource.rrd\""
  1439. rrdfetch_cmd+=" AVERAGE ${opts_rrdfetch[*]} | \\"$'\n'
  1440. rrdfetch_cmd+=" tail -n +2 | \\"$'\n'
  1441. rrdfetch_cmd+=" egrep -v \"^$\" | sed -r \"s/ -?nan/ -/g;s/^([0-9]+): /\\1 /g\"'"
  1442. rrdfetch_cmd_bash=$(eval echo "${rrdfetch_cmd}")
  1443. rrdfetch_cmd_bash=${rrdfetch_cmd_bash#< }
  1444. first_ts=
  1445. first_ts=$(eval "$rrdfetch_cmd_bash" | head -n 1 | cut -f 1 -d " ")
  1446. if [ -z "$first_ts" ]; then
  1447. warn "No data for $resource on vps $vps, skipping..."
  1448. continue
  1449. fi
  1450. last_ts=$(eval "$rrdfetch_cmd_bash" | tail -n 1 | cut -f 1 -d " ")
  1451. if [[ -z "$data_start_ts" ]] || [[ "$data_start_ts" > "$first_ts" ]]; then
  1452. data_start_ts="$first_ts"
  1453. fi
  1454. if [[ -z "$data_stop_ts" ]] || [[ "$data_stop_ts" < "$last_ts" ]]; then
  1455. data_stop_ts="$last_ts"
  1456. fi
  1457. if [ -n "$first" ]; then
  1458. first=
  1459. echo "plot \\"
  1460. else
  1461. echo ", \\"
  1462. fi
  1463. container="${container//\'/}"
  1464. container="${container//@/\\@}"
  1465. echo -n " ${rrdfetch_cmd} u 1:$col_num w lines title '${label}'"
  1466. done
  1467. echo
  1468. }
  1469. cmdline.spec.gnu vps-subscribe
  1470. cmdline.spec::cmd:vps-subscribe:run() {
  1471. :
  1472. }
  1473. cmdline.spec.gnu add
  1474. cmdline.spec:vps-subscribe:cmd:add:run() {
  1475. : :posarg: CHANNEL 'Channel which will be sent to given topic'
  1476. : :posarg: TOPIC 'Ntfy topic to recieve messages of given channel
  1477. (format: "[MYSERVER:]MYTOPICS"
  1478. Examples: "ntfy.0k.io:main,storage,alerts",
  1479. "main{1,3,7}"
  1480. )'
  1481. : :posarg: [VPS...] 'Target host(s) to get stats'
  1482. printf "%s\0" "$CHANNEL" "$TOPIC" |
  1483. vps_mux subscribe:add "${VPS[@]}"
  1484. }
  1485. cmdline.spec.gnu rm
  1486. cmdline.spec:vps-subscribe:cmd:rm:run() {
  1487. : :posarg: CHANNEL 'Channel which will be sent to given topic'
  1488. : :posarg: TOPIC 'Ntfy topic to recieve messages of given channel
  1489. (format: "[MYSERVER:]MYTOPICS"
  1490. Examples: "ntfy.0k.io:main,storage,alerts",
  1491. "main{1,3,7}"
  1492. )'
  1493. : :posarg: [VPS...] 'Target host(s) to get stats'
  1494. printf "%s\0" "$CHANNEL" "$TOPIC" |
  1495. vps_mux subscribe:rm "${VPS[@]}"
  1496. }
  1497. cmdline::parse "$@"